/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the ListCveRecordsResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ListCveRecordsResponse{}

// ListCveRecordsResponse struct for ListCveRecordsResponse
type ListCveRecordsResponse struct {
	TotalCount *int32 `json:"totalCount,omitempty"`
	ItemsPerPage *int32 `json:"itemsPerPage,omitempty"`
	PageCount *int32 `json:"pageCount,omitempty"`
	CurrentPage *int32 `json:"currentPage,omitempty"`
	PrevPage *int32 `json:"prevPage,omitempty"`
	NextPage *int32 `json:"nextPage,omitempty"`
	CveRecords []ListCveRecordsResponseCveRecordsInner `json:"cveRecords,omitempty"`
}

// NewListCveRecordsResponse instantiates a new ListCveRecordsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListCveRecordsResponse() *ListCveRecordsResponse {
	this := ListCveRecordsResponse{}
	return &this
}

// NewListCveRecordsResponseWithDefaults instantiates a new ListCveRecordsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListCveRecordsResponseWithDefaults() *ListCveRecordsResponse {
	this := ListCveRecordsResponse{}
	return &this
}

// GetTotalCount returns the TotalCount field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetTotalCount() int32 {
	if o == nil || IsNil(o.TotalCount) {
		var ret int32
		return ret
	}
	return *o.TotalCount
}

// GetTotalCountOk returns a tuple with the TotalCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetTotalCountOk() (*int32, bool) {
	if o == nil || IsNil(o.TotalCount) {
		return nil, false
	}
	return o.TotalCount, true
}

// HasTotalCount returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasTotalCount() bool {
	if o != nil && !IsNil(o.TotalCount) {
		return true
	}

	return false
}

// SetTotalCount gets a reference to the given int32 and assigns it to the TotalCount field.
func (o *ListCveRecordsResponse) SetTotalCount(v int32) {
	o.TotalCount = &v
}

// GetItemsPerPage returns the ItemsPerPage field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetItemsPerPage() int32 {
	if o == nil || IsNil(o.ItemsPerPage) {
		var ret int32
		return ret
	}
	return *o.ItemsPerPage
}

// GetItemsPerPageOk returns a tuple with the ItemsPerPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetItemsPerPageOk() (*int32, bool) {
	if o == nil || IsNil(o.ItemsPerPage) {
		return nil, false
	}
	return o.ItemsPerPage, true
}

// HasItemsPerPage returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasItemsPerPage() bool {
	if o != nil && !IsNil(o.ItemsPerPage) {
		return true
	}

	return false
}

// SetItemsPerPage gets a reference to the given int32 and assigns it to the ItemsPerPage field.
func (o *ListCveRecordsResponse) SetItemsPerPage(v int32) {
	o.ItemsPerPage = &v
}

// GetPageCount returns the PageCount field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetPageCount() int32 {
	if o == nil || IsNil(o.PageCount) {
		var ret int32
		return ret
	}
	return *o.PageCount
}

// GetPageCountOk returns a tuple with the PageCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetPageCountOk() (*int32, bool) {
	if o == nil || IsNil(o.PageCount) {
		return nil, false
	}
	return o.PageCount, true
}

// HasPageCount returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasPageCount() bool {
	if o != nil && !IsNil(o.PageCount) {
		return true
	}

	return false
}

// SetPageCount gets a reference to the given int32 and assigns it to the PageCount field.
func (o *ListCveRecordsResponse) SetPageCount(v int32) {
	o.PageCount = &v
}

// GetCurrentPage returns the CurrentPage field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetCurrentPage() int32 {
	if o == nil || IsNil(o.CurrentPage) {
		var ret int32
		return ret
	}
	return *o.CurrentPage
}

// GetCurrentPageOk returns a tuple with the CurrentPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetCurrentPageOk() (*int32, bool) {
	if o == nil || IsNil(o.CurrentPage) {
		return nil, false
	}
	return o.CurrentPage, true
}

// HasCurrentPage returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasCurrentPage() bool {
	if o != nil && !IsNil(o.CurrentPage) {
		return true
	}

	return false
}

// SetCurrentPage gets a reference to the given int32 and assigns it to the CurrentPage field.
func (o *ListCveRecordsResponse) SetCurrentPage(v int32) {
	o.CurrentPage = &v
}

// GetPrevPage returns the PrevPage field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetPrevPage() int32 {
	if o == nil || IsNil(o.PrevPage) {
		var ret int32
		return ret
	}
	return *o.PrevPage
}

// GetPrevPageOk returns a tuple with the PrevPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetPrevPageOk() (*int32, bool) {
	if o == nil || IsNil(o.PrevPage) {
		return nil, false
	}
	return o.PrevPage, true
}

// HasPrevPage returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasPrevPage() bool {
	if o != nil && !IsNil(o.PrevPage) {
		return true
	}

	return false
}

// SetPrevPage gets a reference to the given int32 and assigns it to the PrevPage field.
func (o *ListCveRecordsResponse) SetPrevPage(v int32) {
	o.PrevPage = &v
}

// GetNextPage returns the NextPage field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetNextPage() int32 {
	if o == nil || IsNil(o.NextPage) {
		var ret int32
		return ret
	}
	return *o.NextPage
}

// GetNextPageOk returns a tuple with the NextPage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetNextPageOk() (*int32, bool) {
	if o == nil || IsNil(o.NextPage) {
		return nil, false
	}
	return o.NextPage, true
}

// HasNextPage returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasNextPage() bool {
	if o != nil && !IsNil(o.NextPage) {
		return true
	}

	return false
}

// SetNextPage gets a reference to the given int32 and assigns it to the NextPage field.
func (o *ListCveRecordsResponse) SetNextPage(v int32) {
	o.NextPage = &v
}

// GetCveRecords returns the CveRecords field value if set, zero value otherwise.
func (o *ListCveRecordsResponse) GetCveRecords() []ListCveRecordsResponseCveRecordsInner {
	if o == nil || IsNil(o.CveRecords) {
		var ret []ListCveRecordsResponseCveRecordsInner
		return ret
	}
	return o.CveRecords
}

// GetCveRecordsOk returns a tuple with the CveRecords field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListCveRecordsResponse) GetCveRecordsOk() ([]ListCveRecordsResponseCveRecordsInner, bool) {
	if o == nil || IsNil(o.CveRecords) {
		return nil, false
	}
	return o.CveRecords, true
}

// HasCveRecords returns a boolean if a field has been set.
func (o *ListCveRecordsResponse) HasCveRecords() bool {
	if o != nil && !IsNil(o.CveRecords) {
		return true
	}

	return false
}

// SetCveRecords gets a reference to the given []ListCveRecordsResponseCveRecordsInner and assigns it to the CveRecords field.
func (o *ListCveRecordsResponse) SetCveRecords(v []ListCveRecordsResponseCveRecordsInner) {
	o.CveRecords = v
}

func (o ListCveRecordsResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ListCveRecordsResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TotalCount) {
		toSerialize["totalCount"] = o.TotalCount
	}
	if !IsNil(o.ItemsPerPage) {
		toSerialize["itemsPerPage"] = o.ItemsPerPage
	}
	if !IsNil(o.PageCount) {
		toSerialize["pageCount"] = o.PageCount
	}
	if !IsNil(o.CurrentPage) {
		toSerialize["currentPage"] = o.CurrentPage
	}
	if !IsNil(o.PrevPage) {
		toSerialize["prevPage"] = o.PrevPage
	}
	if !IsNil(o.NextPage) {
		toSerialize["nextPage"] = o.NextPage
	}
	if !IsNil(o.CveRecords) {
		toSerialize["cveRecords"] = o.CveRecords
	}
	return toSerialize, nil
}

type NullableListCveRecordsResponse struct {
	value *ListCveRecordsResponse
	isSet bool
}

func (v NullableListCveRecordsResponse) Get() *ListCveRecordsResponse {
	return v.value
}

func (v *NullableListCveRecordsResponse) Set(val *ListCveRecordsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListCveRecordsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListCveRecordsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListCveRecordsResponse(val *ListCveRecordsResponse) *NullableListCveRecordsResponse {
	return &NullableListCveRecordsResponse{value: val, isSet: true}
}

func (v NullableListCveRecordsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListCveRecordsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


